<?php

/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Models;

use App\Http\Base\BaseModel;
use App\Http\Providers\iam\core\model\OracleOCIConnector;
use Carbon\Carbon;
use Illuminate\Database\Capsule\Manager;
use Illuminate\Support\Facades\DB;

class VoyageModel extends BaseModel
{
    /**
     * table name from database
     */
    protected $table = "voyages";

    /**
     *   alias table for relation issues
     */
    protected $aliasTable = "voyages";

    /**
     * primary key from table remember eloquent doesnt support composite primary key
     */
    protected $primaryKey = "id";
    /**
     * check the incrementing boolean if the incrementing from database is false then the value is false by default
     */
    // public $incrementing = false;
    /**
     * fillable property for eloquent attribute cast
     */
    protected $fillable = [
        "id", "voyageKode", "voyageName", "date_updated", "enabled_flex", "voyage_from", "voyage_to", "tahun", "kapalId", "voyage_num", "call_num", "docking_num"
    ];
    /**
     * Creating raw object from table that, this purpose for making you easier for remembering all attribute
     */


    /**
     * paging for default paging purpose
     * if you want to add new paging property you have to add the property in this array
     * you have to add the relation value
     * remember this is not suported casting value you have to handle by your self
     */
    protected $aliasPaging = [
        "voyageKode" => "voyages.voyageKode",
        "voyageName" => "voyages.voyageName"
    ];

    public function syncErrorFromOracleHO($voyageID, $kapalID, $fromCMS = false)
    {
        echo "start sync recovery voyages data from oracle", PHP_EOL;
        (new LogsyncoracleModel)->setLogSync("Master Voyages", Carbon::now()->toDateTimeString(), "", "start");
        $oracleOCI = new OracleOCIConnector();
        $oracleOCI->getConnection()->select(self::getSyncErrorOracleQuery($voyageID, $kapalID))->execute();
        $rows = $oracleOCI->fetchAll();
        $return = false;
        if ($rows) {
            $item = new self();
            $return = $item->storingDataFromOracle($rows, $fromCMS);
        }
        (new LogsyncoracleModel)->setLogSync("Master Voyages", Carbon::now()->toDateTimeString(), "", "success");
        $oracleOCI->closeConnection();
        return $return;
    }

    public function syncFromOracleHO($syncTable, $fromCMS = false)
    {
        echo "start voyages data from oracle", PHP_EOL;
        (new LogsyncoracleModel)->setLogSync("Master Voyages", Carbon::now()->toDateTimeString(), "", "start");
        $oracleOCI = new OracleOCIConnector();
        $lastUpdate = $syncTable->last_sync;
        $oracleOCI->getConnection()->select(self::getOracleQuery($syncTable, 0, 0))->execute();
        while (($rows = $oracleOCI->fetchAll()) !== false) {
            $item = new self();
            $item->storingDataFromOracle($rows, $fromCMS);
            if (!empty($rows->LAST_UPDATE_DATE)) $lastUpdate = $rows->LAST_UPDATE_DATE;
            $syncTable = \App\Http\Models\SyncUtilities\StagingSyncTableModel::find($syncTable->id);
            $syncTable->last_sync = $lastUpdate;
            $syncTable->update();
        }
        (new LogsyncoracleModel)->setLogSync("Master Voyages", Carbon::now()->toDateTimeString(), "", "success");
        $oracleOCI->closeConnection();
    }

    public static function getSyncErrorOracleQuery($voyageID, $kapalID)
    {
        $query = "  SELECT VOYAGEV.*
                    FROM pelni_voyage_v VOYAGEV
                    WHERE VOYAGEV.VOYAGE_ID = '" . $voyageID . "' AND VOYAGEV.ORGANIZATION_ID = '" . $kapalID . "'";
        return $query;
    }

    public static function getOracleQuery($staging, $startRow, $endRow)
    {
        $query = "  SELECT VOYAGEV.*
                    FROM pelni_voyage_v VOYAGEV
                    WHERE VOYAGEV.LAST_UPDATE_DATE >= TO_DATE('" . Carbon::parse($staging->last_sync)->toDateTimeString() . "', 'yyyy - mm - dd HH24:MI:SS')
                    ORDER BY VOYAGEV.LAST_UPDATE_DATE ASC, VOYAGEV.VOYAGE_ID ";
        return $query;
    }

    /*
     * WHERE
      VOYAGEV.LAST_UPDATE_DATE >= TO_DATE('" . Carbon::parse($staging->last_sync)->toDateTimeString() . "', 'yyyy - mm - dd HH24:MI:SS')
     */
    public function mapperOracle($oracle)
    {
        $this->voyageKode = $oracle->VOYAGE_ID;
        $this->voyageName = $oracle->SEGMENT1;
        $this->date_updated = $oracle->LAST_UPDATE_DATE;
        $this->voyage_from = $oracle->DATE_START;
        $this->voyage_to = $oracle->DATE_END;
        $this->tahun = $oracle->TAHUN;
        $this->kapalId = $oracle->ORGANIZATION_ID;
        $this->voyage_num = $oracle->VOYAGE_NUM;
        $this->call_num = $oracle->CALL_NUM;
        $this->docking_num = $oracle->DOCKING_NUM;
    }

    public function storingDataFromOracle($oracle, $fromCMS = false)
    {
        // if(intval($oracle->VOYAGE_ID) >= 0) {
        echo $oracle->VOYAGE_ID . "\n";
        $modelExist = (new self())->getQuery()
            ->where("voyages.voyageKode", "ILIKE", $oracle->VOYAGE_ID)
            ->where("voyages.kapalId", "=", $oracle->ORGANIZATION_ID)
            // ->where("voyages.tahun", "ILIKE", $oracle->TAHUN)
            ->first();
        if (!$modelExist) {
            if ($fromCMS) {
                DB::beginTransaction();
            } else {
                Manager::beginTransaction();
            }  // DB::beginTransaction();
            try {
                $model = new self();
                $model->mapperOracle($oracle);
                $model->save();
                if ($fromCMS) {
                    DB::commit();
                } else {
                    Manager::commit();
                }
                (new LogsyncoracleModel)->setLogSync("Master Voyages - " . $oracle->VOYAGE_ID . " - " . $oracle->SEGMENT1, Carbon::now()->toDateTimeString(), "", "inserted");
                return true;
            } catch (\Exception $exception) {
                if ($fromCMS) {
                    DB::rollBack();
                } else {
                    Manager::rollBack();
                }
                // FUNCTION TO INSERT INTO SYNCERROR TABLE IN CASE THE PROCESS ABOVE HAS SOME ERROR
                $params = json_encode([
                    "VOYAGE_ID" => $oracle->VOYAGE_ID,
                    "ORGANIZATION_ID" => $oracle->ORGANIZATION_ID
                ]);
                $data = json_encode($oracle);
                (new SyncerrorModel)->saveError("pelni_voyage_v", $params, $data, "HO");

                echo $oracle->SEGMENT1 . " " . $exception->getMessage(), PHP_EOL;
                (new LogsyncoracleModel)->setLogSync("Master Voyages - " . $oracle->VOYAGE_ID . " - " . $oracle->SEGMENT1, Carbon::now()->toDateTimeString(), $exception->getMessage(), "failed");
                return false;
            }
        } else {
            if ($fromCMS) {
                DB::beginTransaction();
            } else {
                Manager::beginTransaction();
            }
            try {
                $model = self::find($modelExist->id);
                $model->mapperOracle($oracle);
                $model->update();
                if ($fromCMS) {
                    DB::commit();
                } else {
                    Manager::commit();
                } // DB::commit();
                (new LogsyncoracleModel)->setLogSync("Master Voyages - " . $oracle->VOYAGE_ID . " - " . $oracle->SEGMENT1, Carbon::now()->toDateTimeString(), "", "updated");
                return true;
            } catch (\Exception $exception) {
                if ($fromCMS) {
                    DB::rollBack();
                } else {
                    Manager::rollBack();
                }
                echo $oracle->SEGMENT1 . " " . $exception->getMessage(), PHP_EOL;
                (new LogsyncoracleModel)->setLogSync("Master Voyages - " . $oracle->VOYAGE_ID . " - " . $oracle->SEGMENT1, Carbon::now()->toDateTimeString(), $exception->getMessage(), "failed");
                return false;
            }
        }
        // }

    }

    public static function storeFromHO($data, $fromCMS = false)
    {
        // if(intval($data->voyageKode) >= 0) {
        $modelExist = (new self())->getQuery()
            ->where("voyages.voyageKode", "=", $data->voyageKode)
            ->where("voyages.kapalId", "=", $data->kapalId)
            ->first();
        if (!$modelExist) {
            if ($fromCMS) {
                DB::beginTransaction();
            } else {
                Manager::beginTransaction();
            }
            try {
                $model = new self();
                $model->voyageKode = $data->voyageKode;
                $model->voyageName = $data->voyageName;
                $model->date_updated = $data->date_updated;
                $model->voyage_from = $data->voyage_from;
                $model->voyage_to = $data->voyage_to;
                $model->tahun = $data->tahun;
                $model->kapalId = $data->kapalId;
                $model->voyage_num = $data->voyage_num;
                $model->call_num = $data->call_num;
                $model->docking_num = $data->docking_num;
                $model->save();
                if ($fromCMS) {
                    DB::commit();
                } else {
                    Manager::commit();
                }
                (new LogsynckapalModel)->setLogSync("Voyages HO to Kapal " . $data->voyageKode . " - " . $data->voyageName, Carbon::now()->toDateTimeString(), "", "inserted");
                return true;
            } catch (\Exception $exception) {
                if ($fromCMS) {
                    DB::rollBack();
                } else {
                    Manager::rollBack();
                }
                // FUNCTION TO INSERT INTO SYNCERROR TABLE IN CASE THE PROCESS ABOVE HAS SOME ERROR
                $params = json_encode([
                    "voyageKode" => $data->voyageKode,
                    "kapalId" => $data->kapalId
                ]);
                $dataError = json_encode($data);
                (new SyncerrorModel)->saveError("voyages", $params, $dataError, "KAPAL");
                (new LogsynckapalModel)->setLogSync("Voyages HO to Kapal " . $data->voyageKode . " - " . $data->voyageName, Carbon::now()->toDateTimeString(), $exception->getMessage(), "failed");
                return false;
            }
        } else {
            try {
                $model = self::find($modelExist->id);
                $model->voyageKode = $data->voyageKode;
                $model->voyageName = $data->voyageName;
                $model->date_updated = $data->date_updated;
                $model->voyage_from = $data->voyage_from;
                $model->voyage_to = $data->voyage_to;
                $model->tahun = $data->tahun;
                $model->kapalId = $data->kapalId;
                $model->voyage_num = $data->voyage_num;
                $model->call_num = $data->call_num;
                $model->docking_num = $data->docking_num;
                $model->update();
                (new LogsynckapalModel)->setLogSync("Voyages HO to Kapal " . $data->voyageKode . " - " . $data->voyageName, Carbon::now()->toDateTimeString(), "", "updated");
                return true;
            } catch (\Exception $exception) {
                (new LogsynckapalModel)->setLogSync("Voyages HO to Kapal " . $data->voyageKode . " - " . $data->voyageName, Carbon::now()->toDateTimeString(), "Failed to Update Voyage <br /> " . $exception->getMessage(), "failed");
                return false;
            }
        }
        // }
    }

    public static function getVoyages($fromCMS = false)
    {
        $url = $GLOBALS["env"]["HEAD_OFFICE_URL"] . "/api/sync_voyages";
        $syncTable = (new \App\Http\Models\SyncUtilities\SyncTableHandlerModel())->getQuery()->where("sync_table.id", "=", 10)->first();
        $fetch = true;
        $page = 1;
        (new LogsynckapalModel)->setLogSync("Voyages HO to Kapal", Carbon::now()->toDateTimeString(), "", "start");
        do {
            if ($syncTable) {
                $lastUpdate = Carbon::parse($syncTable->last_sync)->toAtomString();
                $url = $url . "?date_updated=" . $lastUpdate .  "&page=" . $page;
                $syncHandler = new \App\Http\Handler\CurlHandler();
                try {
                    $response = $syncHandler->setUrl($url)->send();
                    $res = json_decode($response, false);
                    $no = 1;
                    if (!empty($res->data)) {
                        foreach ($res->data as $item) {
                            echo "data " . $no;
                            \App\Http\Models\VoyageModel::storeFromHO($item, $fromCMS);
                            $lastUpdate = $item->date_updated;
                            $no = $no + 1;
                        }
                        $sync = \App\Http\Models\SyncUtilities\SyncTableHandlerModel::find($syncTable->id);
                        $sync->last_sync = $lastUpdate;
                        $sync->update();
                    } else {
                        $fetch = false;
                    }
                } catch (\Exception $e) {
                    echo $e->getMessage();
                    (new LogsynckapalModel)->setLogSync("Voyages HO to Kapal", Carbon::now()->toDateTimeString(), $e->getMessage(), "failed");
                }
                $page = $page + 1;
            }
        } while ($fetch);
        (new LogsynckapalModel)->setLogSync("Voyages HO to Kapal", Carbon::now()->toDateTimeString(), "", "success");
    }
}
